searchNodes=[{"doc":"Depot is a filesystem abstraction for elixir providing a unified interface over many implementations. It allows you to swap out filesystems on the fly without needing to rewrite all of your application code in the process. It can eliminate vendor-lock in, reduce technical debt, and improve the testability of your code. This library is based on the ideas of flysystem , which is a PHP library providing similar functionality. Examples defmodule LocalFileSystem do use Depot.Filesystem , adapter : Depot.Adapter.Local , prefix : prefix end LocalFileSystem . write ( &quot;test.txt&quot; , &quot;Hello World&quot; ) { :ok , &quot;Hello World&quot; } = LocalFileSystem . read ( &quot;test.txt&quot; )","ref":"Depot.html","title":"Depot","type":"module"},{"doc":"Clear the filesystem. This is always recursive. Examples Direct filesystem filesystem = Depot.Adapter.Local . configure ( prefix : &quot;/home/user/storage&quot; ) :ok = Depot . clear ( filesystem ) Module-based filesystem defmodule LocalFileSystem do use Depot.Filesystem , adapter : Depot.Adapter.Local , prefix : &quot;/home/user/storage&quot; end LocalFileSystem . clear ( )","ref":"Depot.html#clear/2","title":"Depot.clear/2","type":"function"},{"doc":"Copy a file from source to destination on a filesystem Examples Direct filesystem filesystem = Depot.Adapter.Local . configure ( prefix : &quot;/home/user/storage&quot; ) :ok = Depot . copy ( filesystem , &quot;test.txt&quot; , &quot;other-test.txt&quot; ) Module-based filesystem defmodule LocalFileSystem do use Depot.Filesystem , adapter : Depot.Adapter.Local , prefix : &quot;/home/user/storage&quot; end :ok = LocalFileSystem . copy ( &quot;test.txt&quot; , &quot;other-test.txt&quot; )","ref":"Depot.html#copy/4","title":"Depot.copy/4","type":"function"},{"doc":"Copy a file from one filesystem to the other This can either be done natively if the same adapter is used for both filesystems or by streaming/read-write cycle the file from the source to the local system and back to the destination. Examples Direct filesystem filesystem_source = Depot.Adapter.Local . configure ( prefix : &quot;/home/user/storage&quot; ) filesystem_destination = Depot.Adapter.Local . configure ( prefix : &quot;/home/user/storage2&quot; ) :ok = Depot . copy_between_filesystem ( { filesystem_source , &quot;test.txt&quot; } , { filesystem_destination , &quot;copy.txt&quot; } ) Module-based filesystem defmodule LocalSourceFileSystem do use Depot.Filesystem , adapter : Depot.Adapter.Local , prefix : &quot;/home/user/storage&quot; end defmodule LocalDestinationFileSystem do use Depot.Filesystem , adapter : Depot.Adapter.Local , prefix : &quot;/home/user/storage2&quot; end :ok = Depot . copy_between_filesystem ( { LocalSourceFileSystem . __filesystem__ ( ) , &quot;test.txt&quot; } , { LocalDestinationFileSystem . __filesystem__ ( ) , &quot;copy.txt&quot; } )","ref":"Depot.html#copy_between_filesystem/3","title":"Depot.copy_between_filesystem/3","type":"function"},{"doc":"Create a directory Examples Direct filesystem filesystem = Depot.Adapter.Local . configure ( prefix : &quot;/home/user/storage&quot; ) :ok = Depot . create_directory ( filesystem , &quot;test/&quot; ) Module-based filesystem defmodule LocalFileSystem do use Depot.Filesystem , adapter : Depot.Adapter.Local , prefix : &quot;/home/user/storage&quot; end LocalFileSystem . create_directory ( &quot;test/&quot; )","ref":"Depot.html#create_directory/3","title":"Depot.create_directory/3","type":"function"},{"doc":"Delete a file from a filesystem Examples Direct filesystem filesystem = Depot.Adapter.Local . configure ( prefix : &quot;/home/user/storage&quot; ) :ok = Depot . delete ( filesystem , &quot;test.txt&quot; ) Module-based filesystem defmodule LocalFileSystem do use Depot.Filesystem , adapter : Depot.Adapter.Local , prefix : &quot;/home/user/storage&quot; end :ok = LocalFileSystem . delete ( &quot;test.txt&quot; )","ref":"Depot.html#delete/3","title":"Depot.delete/3","type":"function"},{"doc":"Delete a directory. Options :recursive - Recursively delete contents. Defaults to false . Examples Direct filesystem filesystem = Depot.Adapter.Local . configure ( prefix : &quot;/home/user/storage&quot; ) :ok = Depot . delete_directory ( filesystem , &quot;test/&quot; ) Module-based filesystem defmodule LocalFileSystem do use Depot.Filesystem , adapter : Depot.Adapter.Local , prefix : &quot;/home/user/storage&quot; end LocalFileSystem . delete_directory ( &quot;test/&quot; )","ref":"Depot.html#delete_directory/3","title":"Depot.delete_directory/3","type":"function"},{"doc":"Copy a file from source to destination on a filesystem Examples Direct filesystem filesystem = Depot.Adapter.Local . configure ( prefix : &quot;/home/user/storage&quot; ) :ok = Depot . copy ( filesystem , &quot;test.txt&quot; , &quot;other-test.txt&quot; ) Module-based filesystem defmodule LocalFileSystem do use Depot.Filesystem , adapter : Depot.Adapter.Local , prefix : &quot;/home/user/storage&quot; end :ok = LocalFileSystem . copy ( &quot;test.txt&quot; , &quot;other-test.txt&quot; )","ref":"Depot.html#file_exists/3","title":"Depot.file_exists/3","type":"function"},{"doc":"List the contents of a folder on a filesystem Examples Direct filesystem filesystem = Depot.Adapter.Local . configure ( prefix : &quot;/home/user/storage&quot; ) { :ok , contents } = Depot . list_contents ( filesystem , &quot;.&quot; ) Module-based filesystem defmodule LocalFileSystem do use Depot.Filesystem , adapter : Depot.Adapter.Local , prefix : &quot;/home/user/storage&quot; end { :ok , contents } = LocalFileSystem . list_contents ( &quot;.&quot; )","ref":"Depot.html#list_contents/3","title":"Depot.list_contents/3","type":"function"},{"doc":"Move a file from source to destination on a filesystem Examples Direct filesystem filesystem = Depot.Adapter.Local . configure ( prefix : &quot;/home/user/storage&quot; ) :ok = Depot . move ( filesystem , &quot;test.txt&quot; , &quot;other-test.txt&quot; ) Module-based filesystem defmodule LocalFileSystem do use Depot.Filesystem , adapter : Depot.Adapter.Local , prefix : &quot;/home/user/storage&quot; end :ok = LocalFileSystem . move ( &quot;test.txt&quot; , &quot;other-test.txt&quot; )","ref":"Depot.html#move/4","title":"Depot.move/4","type":"function"},{"doc":"Read from a filesystem Examples Direct filesystem filesystem = Depot.Adapter.Local . configure ( prefix : &quot;/home/user/storage&quot; ) { :ok , &quot;Hello World&quot; } = Depot . read ( filesystem , &quot;test.txt&quot; ) Module-based filesystem defmodule LocalFileSystem do use Depot.Filesystem , adapter : Depot.Adapter.Local , prefix : &quot;/home/user/storage&quot; end { :ok , &quot;Hello World&quot; } = LocalFileSystem . read ( &quot;test.txt&quot; )","ref":"Depot.html#read/3","title":"Depot.read/3","type":"function"},{"doc":"Returns a Stream for reading the given path . Options The following stream options apply to all adapters: :chunk_size - When reading, the amount to read, usually expressed as a number of bytes. Examples Note: The shape of the returned stream will necessarily depend on the adapter in use. In the following examples the Local adapter is invoked, which returns a File.Stream . Direct filesystem filesystem = Depot.Adapter.Local . configure ( prefix : &quot;/home/user/storage&quot; ) { :ok , % File.Stream { } } = Depot . read_stream ( filesystem , &quot;test.txt&quot; ) Module-based filesystem defmodule LocalFileSystem do use Depot.Filesystem , adapter : Depot.Adapter.Local , prefix : &quot;/home/user/storage&quot; end { :ok , % File.Stream { } } = LocalFileSystem . read_stream ( &quot;test.txt&quot; )","ref":"Depot.html#read_stream/3","title":"Depot.read_stream/3","type":"function"},{"doc":"Write to a filesystem Examples Direct filesystem filesystem = Depot.Adapter.Local . configure ( prefix : &quot;/home/user/storage&quot; ) :ok = Depot . write ( filesystem , &quot;test.txt&quot; , &quot;Hello World&quot; ) Module-based filesystem defmodule LocalFileSystem do use Depot.Filesystem , adapter : Depot.Adapter.Local , prefix : &quot;/home/user/storage&quot; end LocalFileSystem . write ( &quot;test.txt&quot; , &quot;Hello World&quot; )","ref":"Depot.html#write/4","title":"Depot.write/4","type":"function"},{"doc":"Returns a Stream for writing to the given path . Options The following stream options apply to all adapters: :chunk_size - When reading, the amount to read, usually expressed as a number of bytes. Examples Note: The shape of the returned stream will necessarily depend on the adapter in use. In the following examples the Local adapter is invoked, which returns a File.Stream . Direct filesystem filesystem = Depot.Adapter.Local . configure ( prefix : &quot;/home/user/storage&quot; ) { :ok , % File.Stream { } } = Depot . write_stream ( filesystem , &quot;test.txt&quot; ) Module-based filesystem defmodule LocalFileSystem do use Depot.Filesystem , adapter : Depot.Adapter.Local , prefix : &quot;/home/user/storage&quot; end { :ok , % File.Stream { } } = LocalFileSystem . write_stream ( &quot;test.txt&quot; )","ref":"Depot.html#write_stream/3","title":"Depot.write_stream/3","type":"function"},{"doc":"","ref":"Depot.html#t:adapter/0","title":"Depot.adapter/0","type":"type"},{"doc":"","ref":"Depot.html#t:filesystem/0","title":"Depot.filesystem/0","type":"type"},{"doc":"Behaviour for how Depot adapters work.","ref":"Depot.Adapter.html","title":"Depot.Adapter","type":"behaviour"},{"doc":"","ref":"Depot.Adapter.html#c:clear/1","title":"Depot.Adapter.clear/1","type":"callback"},{"doc":"","ref":"Depot.Adapter.html#c:configure/1","title":"Depot.Adapter.configure/1","type":"callback"},{"doc":"","ref":"Depot.Adapter.html#c:copy/3","title":"Depot.Adapter.copy/3","type":"callback"},{"doc":"","ref":"Depot.Adapter.html#c:copy/4","title":"Depot.Adapter.copy/4","type":"callback"},{"doc":"","ref":"Depot.Adapter.html#c:create_directory/2","title":"Depot.Adapter.create_directory/2","type":"callback"},{"doc":"","ref":"Depot.Adapter.html#c:delete/2","title":"Depot.Adapter.delete/2","type":"callback"},{"doc":"","ref":"Depot.Adapter.html#c:delete_directory/3","title":"Depot.Adapter.delete_directory/3","type":"callback"},{"doc":"","ref":"Depot.Adapter.html#c:file_exists/2","title":"Depot.Adapter.file_exists/2","type":"callback"},{"doc":"","ref":"Depot.Adapter.html#c:list_contents/2","title":"Depot.Adapter.list_contents/2","type":"callback"},{"doc":"","ref":"Depot.Adapter.html#c:move/3","title":"Depot.Adapter.move/3","type":"callback"},{"doc":"","ref":"Depot.Adapter.html#c:read/2","title":"Depot.Adapter.read/2","type":"callback"},{"doc":"","ref":"Depot.Adapter.html#c:read_stream/3","title":"Depot.Adapter.read_stream/3","type":"callback"},{"doc":"","ref":"Depot.Adapter.html#c:starts_processes/0","title":"Depot.Adapter.starts_processes/0","type":"callback"},{"doc":"","ref":"Depot.Adapter.html#c:write/3","title":"Depot.Adapter.write/3","type":"callback"},{"doc":"","ref":"Depot.Adapter.html#c:write_stream/3","title":"Depot.Adapter.write_stream/3","type":"callback"},{"doc":"","ref":"Depot.Adapter.html#t:config/0","title":"Depot.Adapter.config/0","type":"type"},{"doc":"","ref":"Depot.Adapter.html#t:directory_delete_opts/0","title":"Depot.Adapter.directory_delete_opts/0","type":"type"},{"doc":"","ref":"Depot.Adapter.html#t:path/0","title":"Depot.Adapter.path/0","type":"type"},{"doc":"","ref":"Depot.Adapter.html#t:stream_opts/0","title":"Depot.Adapter.stream_opts/0","type":"type"},{"doc":"","ref":"Depot.AdapterTest.html","title":"Depot.AdapterTest","type":"module"},{"doc":"","ref":"Depot.AdapterTest.html#adapter_test/1","title":"Depot.AdapterTest.adapter_test/1","type":"macro"},{"doc":"","ref":"Depot.AdapterTest.html#adapter_test/2","title":"Depot.AdapterTest.adapter_test/2","type":"macro"},{"doc":"","ref":"Depot.AdapterTest.html#in_list/2","title":"Depot.AdapterTest.in_list/2","type":"macro"},{"doc":"Behaviour of a Depot filesystem.","ref":"Depot.Filesystem.html","title":"Depot.Filesystem","type":"behaviour"},{"doc":"","ref":"Depot.Filesystem.html#c:copy/3","title":"Depot.Filesystem.copy/3","type":"callback"},{"doc":"","ref":"Depot.Filesystem.html#c:delete/2","title":"Depot.Filesystem.delete/2","type":"callback"},{"doc":"","ref":"Depot.Filesystem.html#c:file_exists/2","title":"Depot.Filesystem.file_exists/2","type":"callback"},{"doc":"","ref":"Depot.Filesystem.html#c:list_contents/2","title":"Depot.Filesystem.list_contents/2","type":"callback"},{"doc":"","ref":"Depot.Filesystem.html#c:move/3","title":"Depot.Filesystem.move/3","type":"callback"},{"doc":"","ref":"Depot.Filesystem.html#parse_opts/2","title":"Depot.Filesystem.parse_opts/2","type":"function"},{"doc":"","ref":"Depot.Filesystem.html#c:read/2","title":"Depot.Filesystem.read/2","type":"callback"},{"doc":"","ref":"Depot.Filesystem.html#c:read_stream/2","title":"Depot.Filesystem.read_stream/2","type":"callback"},{"doc":"","ref":"Depot.Filesystem.html#c:write/3","title":"Depot.Filesystem.write/3","type":"callback"},{"doc":"Elixir registry to register adapter instances on for adapters, which need processes. Registration Register instances with the via tuple of: Depot.Registry.via(adapter, name)","ref":"Depot.Registry.html","title":"Depot.Registry","type":"module"},{"doc":"","ref":"Depot.Stat.Dir.html","title":"Depot.Stat.Dir","type":"module"},{"doc":"","ref":"Depot.Stat.File.html","title":"Depot.Stat.File","type":"module"},{"doc":"Depot Adapter using an Agent for in memory storage. Direct usage iex&gt; filesystem = Depot.Adapter.InMemory . configure ( name : InMemoryFileSystem ) iex&gt; start_supervised ( filesystem ) iex&gt; :ok = Depot . write ( filesystem , &quot;test.txt&quot; , &quot;Hello World&quot; ) iex&gt; { :ok , &quot;Hello World&quot; } = Depot . read ( filesystem , &quot;test.txt&quot; ) Usage with a module defmodule InMemoryFileSystem do use Depot.Filesystem , adapter : Depot.Adapter.InMemory end start_supervised ( InMemoryFileSystem ) InMemoryFileSystem . write ( &quot;test.txt&quot; , &quot;Hello World&quot; ) { :ok , &quot;Hello World&quot; } = InMemoryFileSystem . read ( &quot;test.txt&quot; )","ref":"Depot.Adapter.InMemory.html","title":"Depot.Adapter.InMemory","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Depot.Adapter.InMemory.html#child_spec/1","title":"Depot.Adapter.InMemory.child_spec/1","type":"function"},{"doc":"","ref":"Depot.Adapter.InMemory.html#start_link/1","title":"Depot.Adapter.InMemory.start_link/1","type":"function"},{"doc":"","ref":"Depot.Adapter.InMemory.AgentStream.html","title":"Depot.Adapter.InMemory.AgentStream","type":"module"},{"doc":"Depot Adapter for the local filesystem. Direct usage iex&gt; { :ok , prefix } = Briefly . create ( directory : true ) iex&gt; filesystem = Depot.Adapter.Local . configure ( prefix : prefix ) iex&gt; :ok = Depot . write ( filesystem , &quot;test.txt&quot; , &quot;Hello World&quot; ) iex&gt; { :ok , &quot;Hello World&quot; } = Depot . read ( filesystem , &quot;test.txt&quot; ) Usage with a module defmodule LocalFileSystem do use Depot.Filesystem , adapter : Depot.Adapter.Local , prefix : prefix end LocalFileSystem . write ( &quot;test.txt&quot; , &quot;Hello World&quot; ) { :ok , &quot;Hello World&quot; } = LocalFileSystem . read ( &quot;test.txt&quot; ) Usage with Streams The following options are available for streams: :chunk_size - When reading, the amount to read, by :line (default) or by a given number of bytes. :modes - A list of modes to use when opening the file for reading. For more information, see the docs for File.stream!/3 . Examples { :ok , % File.Stream { } } = Depot . read_stream ( filesystem , &quot;test.txt&quot; ) # with custom read chunk size { :ok , % File.Stream { line_or_bytes : 1_024 , ... } } = Depot . read_stream ( filesystem , &quot;test.txt&quot; , chunk_size : 1_024 ) # with custom file read modes { :ok , % File.Stream { mode : [ { :encoding , :utf8 } , :binary ] , ... } } = Depot . read_stream ( filesystem , &quot;test.txt&quot; , modes : [ encoding : :utf8 ] )","ref":"Depot.Adapter.Local.html","title":"Depot.Adapter.Local","type":"module"}]